Subject: Re: bug#36443: Canonicalized build directory name in container leads to confusion (was guix build mixes build dirs?)
From: Ludovic Courtès <[email-masked]>
To: Robert Vollmert <[email-masked]>
Cc: Mark H Weaver <[email-masked]>, [email-masked]
Date: Thu, 04 Jul 2019 17:12:32 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello,

Robert Vollmert <[email-masked]> skribis:

>> On 4. Jul 2019, at 09:59, Ludovic Courtès <[email-masked]> wrote:
>> 
>> Hi,
>> 
>> “Impossible” is an exaggeration, but when you source the
>> ‘environment-variables’ file, for example, PWD and other variables will
>> refer to /tmp/guix-build-….drv, which won’t exist.  Likewise, generated
>> files such as Makefiles would have captured the ….drv name.
>
> But, wait, won’t they refer to /tmp/guix-build-0.drv? So debugging a build
> from /tmp/guix-build-1.drv will use a mix of both directories?

As the manual explains, the name inside the container is fixed, it’s
always .drv-0; the name outside may vary to avoid naming collisions or
as a consequence of setting TMPDIR.

>> Like Mark writes, it’s not the end of the world: you can simply rename
>> /tmp/guix-build-….drv-0 to /tmp/guix-build-….drv.  However, it means
>> that things would be inconvenient by default, which doesn’t sound great
>> to me.
>> 
>> WDYT?
>
> I don't particularly care anymore. I think it’s a confusing mess, but for
> myself I’ve learnt this wart and won’t run into the problem anymore.

I understand this has been a confusing experience, but I can’t really
think of any other sensible way to approach it.

Anyway, closing it now.  Thank you!

Ludo’.